; ##############################################################################
; ##############################################################################
; ##############################################################################
EXTERNER_INTERUPT_INITIALISIEREN:
;																			
; SLEEP+INT0+INT1 (externer Interrupt) konfigurieren						
;																			
; MCUCR => SE SM2 SM1 SM0 ISC11 ISC10 ISC01 ISC00 							
; SM2 SM1 SM0 Sleep Mode													
;*0   0   0   Idle															
; 0   0   1   ADC Noise Reduction											
; 0   1   0   Power-down													
; 0   1   1   Power-save													
; 1   0   0   Reserved														
; 1   0   1   Reserved														
; 1   1   0   Standby(1)													
;																			
;ISC11 ISC10 Description													
; 0 	0 	The low level of INT1 generates an interrupt request.			
; 0 	1 	Any logical change on INT1 generates an interrupt request.		
;*1 	0 	The falling edge of INT1 generates an interrupt request.		
; 1 	1 	The rising edge of INT1 generates an interrupt request.			
;																			
;ISC01 ISC00 Description													
; 0 	0 	The low level of INT0 generates an interrupt request.			
; 0 	1 	Any logical change on INT0 generates an interrupt request.		
;*1 	0 	The falling edge of INT0 generates an interrupt request.		
; 1 	1 	The rising  edge of INT0 generates an interrupt request.		
;																			
	ldi temp,(1<<SE)|(0<<SM2)|(0<<SM1)|(0<<SM0)|(1<<ISC11)|(0<<ISC10)|(1<<ISC01)|(0<<ISC00) 
	out MCUCR,temp

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXTERNER_INTERRUPT_AKTIVIEREN:
;																			
; INT0+INT1 (externer Interrupt)aktivieren									
;																			
; GICR => INT1 INT0 - - - - IVSEL IVCE 										
; General Interrupt Control													
;																			
	ldi temp, (1<<INT1)|(1<<INT0)|(0<<IVSEL)|(0<<IVCE)   
    out GICR, temp 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXT_INT0:

	sei ; Interrupts freigeben (verschachtelte Interrupts)						

	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
	push TEMP1
	push TEMP2
	push TEMP3
	push TEMP4
	push TEMP5
	push TEMP6
	push TEMP7
	push TEMP8 
	push TEMP9  
	push ZL
	push ZH	
; -------------------------------
	rcall RDS_SAMPLING
	rcall RDS_CRC_TEMP1
	rcall RDS_GRUPPENBILDUNG_TEMP1
	rcall ABFRAGE_TASTATUR
; -------------------------------
	pop ZH
	pop ZL
	pop TEMP9  	
	pop TEMP8
	pop TEMP7
	pop TEMP6
	pop TEMP5
	pop TEMP4
	pop TEMP3
	pop TEMP2
	pop TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXT_INT1:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)

	add FREQA0,EINS
	adc FREQA1,NULL

	add FREQB0,EINS
	adc FREQB1,NULL
	adc FREQB2,NULL

	add FREQC0,EINS
	adc FREQC1,NULL
	adc FREQC2,NULL

	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
ABFRAGE_TASTATUR:
	clr temp
	; Taste gedrckt ?	
	sbis (TASTE1_PIN),(TASTE1_PIN_NR)	; springe, wenn BIT(PIN) high	
	sbr temp,1
	sbis (TASTE2_PIN),(TASTE2_PIN_NR)	; springe, wenn BIT(PIN) high	
	sbr temp,2
	STS(adr_TASTE),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
