; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_CLEAR:
	STS(adr_RDS_PI_L),NULL
	STS(adr_RDS_PI_H),NULL

	STS(adr_RDS_PTY),NULL
	STS(adr_RDS_TP),NULL
	STS(adr_RDS_TA),NULL
	STS(adr_RDS_MS),NULL

	STS(adr_RDS_ZEIT_HH),NULL
	STS(adr_RDS_ZEIT_MM),NULL
	STS(adr_RDS_ZEIT_OFFSET),NULL

	STS(adr_RDS_ZAEHLER_ANZ_GRUPPEN_ERROR_L),NULL
	STS(adr_RDS_ZAEHLER_ANZ_GRUPPEN_ERROR_H),NULL

	STS(adr_RDS_ZAEHLER_ANZ_GRUPPEN_L),NULL
	STS(adr_RDS_ZAEHLER_ANZ_GRUPPEN_H),NULL


	; SCHLEIFE (8)		
	ldi ZL, LOW (adr_RDS_BEREICH_SENDERNAME8)
	ldi ZH, HIGH(adr_RDS_BEREICH_SENDERNAME8)
	ldi temp1,8
	ldi temp,'_'
RDS_CLEAR_w1:
	ST z+,temp
	dec temp1
	brne RDS_CLEAR_w1
	; SCHLEIFE (128)	
	ldi ZL, LOW (adr_RDS_BEREICH_RADIOTEXT128)
	ldi ZH, HIGH(adr_RDS_BEREICH_RADIOTEXT128)
	ldi temp1,128
	ldi temp,'_'
RDS_CLEAR_w2:
	ST z+,temp
	dec temp1
	brne RDS_CLEAR_w2
	; SCHLEIFE (32)		
	ldi ZL, LOW (adr_RDS_BEREICH_GRUPPENNUMMERN32)
	ldi ZH, HIGH(adr_RDS_BEREICH_GRUPPENNUMMERN32)
	ldi temp1,32
RDS_CLEAR_w3:
	ST z+,NULL
	dec temp1
	brne RDS_CLEAR_w3
	; SCHLEIFE (128)	
	ldi ZL, LOW (adr_RDS_BEREICH_AF128)
	ldi ZH, HIGH(adr_RDS_BEREICH_AF128)
	ldi temp1,128
RDS_CLEAR_w4:
	ST z+,NULL
	dec temp1
	brne RDS_CLEAR_w4

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_BUFFER_READ:
	; Z BERECHNEN						
	ldi ZL,LOW (adr_RDS_DISPLAY_BUFFER256)
	ldi ZH,HIGH(adr_RDS_DISPLAY_BUFFER256)
	LDS temp,(adr_RDS_ZAEHLER_BUFFER_READ)
	add ZL,temp
	adc ZH,NULL
	CLI							; Interrupts sperren !				
	; Sind Daten im Puffer vorhanden ?	
	LD  temp,Z					; AH auslesen
	tst temp
	brne RDS_BUFFER_READ_DATA
	; keine DATEN						
	SEI							; Interrupts wieder Freigeben
	ret
;-------------------------------------------------------------------------------
RDS_BUFFER_READ_DATA:
	; ZAEHLER_BUFFER_READ+8			
	LDS temp,(adr_RDS_ZAEHLER_BUFFER_READ)
	subi temp,-8
	STS(adr_RDS_ZAEHLER_BUFFER_READ),temp
;-------------------------------------------------------------------------------
	LD  temp,Z					; AH auslesen
	ST Z,NULL					; NULL
	adiw ZL,1
	STS(adr_RDS_AH),temp	; Data
	LD  temp,Z+
	STS(adr_RDS_AL),temp	; Data
	LD  temp,Z+
	STS(adr_RDS_BH),temp	; Data
	LD  temp,Z+
	STS(adr_RDS_BL),temp	; Data
	LD  temp,Z+
	STS(adr_RDS_CH),temp	; Data
	LD  temp,Z+
	STS(adr_RDS_CL),temp	; Data
	LD  temp,Z+
	STS(adr_RDS_DH),temp	; Data
	LD  temp,Z+
	STS(adr_RDS_DL),temp	; Data
	SEI							; Interrupts wieder Freigeben
;-------------------------------------------------------------------------------
	; SENDERWECHSEL-Erkennung		
	LDS temp1,(adr_RDS_AH)
	LDS temp2,(adr_RDS_AH_OLD)
	LDS temp3,(adr_RDS_AL)
	LDS temp4,(adr_RDS_AL_OLD)
	; Vergleich						
	cp temp1,temp2
	brne RDS_BUFFER_READ_SENDERWECHSEL
	cp temp3,temp4
	brne RDS_BUFFER_READ_SENDERWECHSEL
	rjmp RDS_BUFFER_READ_NO_SENDERWECHSEL
RDS_BUFFER_READ_SENDERWECHSEL:
	; OLD schreiben					
	STS(adr_RDS_AH_OLD),temp1
	STS(adr_RDS_AL_OLD),temp3
	; RDS CLEAR						
	rcall RDS_CLEAR
RDS_BUFFER_READ_NO_SENDERWECHSEL:
;-------------------------------------------------------------------------------
	; RDS_AUSWERTUNG				
	RCALL RDS_AUSWERTUNG
rjmp RDS_BUFFER_READ
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_AUSWERTUNG:
	; NULL BLOCK-A
	LDS temp,(adr_RDS_AH)
	tst temp
	breq RDS_AUSWERTUNG_ERROR
	; NULL BLOCK-A
	LDS temp,(adr_RDS_AL)
	tst temp
	breq RDS_AUSWERTUNG_ERROR
	rjmp RDS_AUSWERTUNG_GRUPPENTYP
;-------------------------------------------------------------------------------
RDS_AUSWERTUNG_ERROR:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_AUSWERTUNG_GRUPPENTYP:
	; PI (wird in allen Gruppen gesendet)		
	LDS temp,(adr_RDS_AH)
	STS(adr_RDS_PI_H),temp	; im SRAM ablegen	
	LDS temp,(adr_RDS_AL)
	STS(adr_RDS_PI_L),temp	; im SRAM ablegen	
	; TP (wird in allen Gruppen gesendet)		
	LDS temp,(adr_RDS_BH)
	andi temp,0b00000100	; Bitmuster			
	STS(adr_RDS_TP),temp	; im SRAM ablegen	
	; PTY (wird in allen Gruppen gesendet)		
	LDS temp1,(adr_RDS_BH)
	LDS temp, (adr_RDS_BL)
	LSR temp1	; 5 mal rechts
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	andi temp,0b00011111	; Bitmuster	
	STS(adr_RDS_PTY),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; GT (Gruppentyp) filtern		
	LDS temp,(adr_RDS_BH)
	LSR temp	; 3 mal rechts
	LSR temp	; 
	LSR temp	; 
	STS(adr_RDS_GT),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; GT fr Anzeige speichern		
	LDS temp,(adr_RDS_GT)
	; Z initialisieren	
	ldi ZL,LOW (adr_RDS_BEREICH_GRUPPENNUMMERN32)
	ldi ZH,HIGH(adr_RDS_BEREICH_GRUPPENNUMMERN32)
	add ZL,temp ; temp addieren
	adc ZH,NULL
	ldi temp,'*'
	ST z+,temp
;-------------------------------------------------------------------------------
	; GT (Gruppentyp) auswerten	
	LDS temp,(adr_RDS_GT)
	; Z initialisieren	
	ldi ZL,LOW (RDS_AUSWERTUNG_SPRUNGMARKE)
	ldi ZH,HIGH(RDS_AUSWERTUNG_SPRUNGMARKE)
	add ZL,temp ; temp addieren
	adc ZH,NULL
	; SPRUNG nach Z		
	ijmp
;-------------------------------------------------------------------------------
RDS_AUSWERTUNG_SPRUNGMARKE:
	rjmp RDS_GT_0A			; Sendername, TA, Musik/Sprache	(M/S)					
	ret		;rjmp RDS_GT_0B
	ret		;rjmp RDS_GT_1A
	ret		;rjmp RDS_GT_1B
	rjmp RDS_GT_2A	 		; Radiotext												
	ret		;rjmp RDS_GT_2B
	ret		;rjmp RDS_GT_3A	; 3A = ODA - Open Data Applications
	ret		;rjmp RDS_GT_3B
	rjmp RDS_GT_4A			; 4A = CT - Clock Time (wird mintlich gesendet)
	ret		;rjmp RDS_GT_4B
	ret		;rjmp RDS_GT_5A
	ret		;rjmp RDS_GT_5B
	ret		;rjmp RDS_GT_6A	; 6A = ???
	ret		;rjmp RDS_GT_6B
	ret		;rjmp RDS_GT_7A
	ret		;rjmp RDS_GT_7B
	ret		;rjmp RDS_GT_8A ; 8A = TMC - Traffic Message Channel
	ret		;rjmp RDS_GT_8B
	ret		;rjmp RDS_GT_9A
	ret		;rjmp RDS_GT_9B
	ret		;rjmp RDS_GT_10A
	ret		;rjmp RDS_GT_10B
	ret		;rjmp RDS_GT_11A
	ret		;rjmp RDS_GT_11B
	ret		;rjmp RDS_GT_12A
	ret		;rjmp RDS_GT_12B
	ret		;rjmp RDS_GT_13A
	ret		;rjmp RDS_GT_13B
	ret		;rjmp RDS_GT_14A ; 14A = EON - Enhanced Other Networks
	ret		;rjmp RDS_GT_14B
	ret		;rjmp RDS_GT_15A
	ret		;rjmp RDS_GT_15B ; 15B = TA - Traffic Announcement
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Sendername, TA, AF, Musik/Sprache	(M/S)										
RDS_GT_0A:
	; TA					
	LDS temp,(adr_RDS_BL)
	andi temp,0b00010000	; Bitmuster			
	STS(adr_RDS_TA),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; MS (MUSIK/Sprache)	
	LDS temp,(adr_RDS_BL)
	andi temp,0b00001000	; Bitmuster			
	STS(adr_RDS_MS),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; AF (Alternativ-Frequenz 1)
	LDS temp1,(adr_RDS_CH)
	rcall RDS_GT_0A_AF_TEMP1
	; AF (Alternativ-Frequenz 2)
	LDS temp1,(adr_RDS_CL)
	rcall RDS_GT_0A_AF_TEMP1
;-------------------------------------------------------------------------------
	; Sendername			
	LDS temp1,(adr_RDS_DH)
	LDS temp2,(adr_RDS_DL)
	; Adresse filtern		
	LDS temp,(adr_RDS_BL)
	andi temp,0b00000011
	cpi temp,0
	breq RDS_0A_ADR0
	cpi temp,1
	breq RDS_0A_ADR1
	cpi temp,2
	breq RDS_0A_ADR2
	cpi temp,3
	breq RDS_0A_ADR3
	; SRAM ablegen			
RDS_0A_ADR0:
	STS(adr_RDS_BEREICH_SENDERNAME8+0),temp1
	STS(adr_RDS_BEREICH_SENDERNAME8+1),temp2
	ret
RDS_0A_ADR1:
	STS(adr_RDS_BEREICH_SENDERNAME8+2),temp1
	STS(adr_RDS_BEREICH_SENDERNAME8+3),temp2
	ret
RDS_0A_ADR2:
	STS(adr_RDS_BEREICH_SENDERNAME8+4),temp1
	STS(adr_RDS_BEREICH_SENDERNAME8+5),temp2
	ret
RDS_0A_ADR3:
	STS(adr_RDS_BEREICH_SENDERNAME8+6),temp1
	STS(adr_RDS_BEREICH_SENDERNAME8+7),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Alternativfrequenz															
RDS_GT_0A_AF_TEMP1:
	cpi temp1,204+1
	brlo RDS_GT_0A_AF_TEMP1_RUN
	ret
RDS_GT_0A_AF_TEMP1_RUN:
	; Z-initialisieren	
	ldi ZL, LOW (adr_RDS_BEREICH_AF128)
	ldi ZH, HIGH(adr_RDS_BEREICH_AF128)
RDS_GT_0A_AF_TEMP1_s:
	; frei ?			
	LD temp,Z
	tst temp
	brne RDS_GT_0A_AF_TEMP1_NO_FREI
RDS_GT_0A_AF_TEMP1_FREI:
	; AF write			
	ST Z,temp1
	ret
RDS_GT_0A_AF_TEMP1_NO_FREI:
	cp temp,temp1
	brne RDS_GT_0A_AF_TEMP1_NO_VORHANDEN
	; AF schon vorhanden
	ret
RDS_GT_0A_AF_TEMP1_NO_VORHANDEN:
	; Z+1				
	adiw ZL,1
rjmp RDS_GT_0A_AF_TEMP1_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Radiotext																		
RDS_GT_2A:
	; Adresse filtern	
	LDS temp9,(adr_RDS_BL)
	andi temp9,0b00011111
	; mal 4				
	LSL temp9	; x2
	LSL temp9	; x2= POSITION
	; Z-initialisieren	
	ldi ZL, LOW (adr_RDS_BEREICH_RADIOTEXT128)
	ldi ZH, HIGH(adr_RDS_BEREICH_RADIOTEXT128)
	add ZL,temp9
	adc ZH,NULL
	; 1.BYTE im SRAM speichern	
	LDS temp,(adr_RDS_CH)
	rcall RDS_GT_2A_SONDERZEICHEN_FILTER
	ST z+,temp
	; 2.BYTE im SRAM speichern	
	LDS temp,(adr_RDS_CL)
	inc temp9	; POSITION+1
	rcall RDS_GT_2A_SONDERZEICHEN_FILTER
	ST z+,temp
	; 3.BYTE im SRAM speichern	
	LDS temp,(adr_RDS_DH)
	inc temp9	; POSITION+1
	rcall RDS_GT_2A_SONDERZEICHEN_FILTER
	ST z+,temp
	; 4.BYTE im SRAM speichern	
	LDS temp,(adr_RDS_DL)
	inc temp9	; POSITION+1
	rcall RDS_GT_2A_SONDERZEICHEN_FILTER
	ST z+,temp
	ret
;-------------------------------------------------------------------------------
RDS_GT_2A_SONDERZEICHEN_FILTER:
	; sonderzeichen erkennen	
	cpi temp,32-1
	brlo RDS_GT_2A_SONDERZEICHEN_FILTER_w
	ret
RDS_GT_2A_SONDERZEICHEN_FILTER_w:
	; Y-initialisieren			
	ldi YL, LOW (adr_RDS_BEREICH_RADIOTEXT128)
	ldi YH, HIGH(adr_RDS_BEREICH_RADIOTEXT128)
	add YL,temp9
	adc YH,NULL
	; Fllzeichen				
	ldi temp,' '
	; BLOCK1 oder BLOCK2		
	cpi temp9,63
	brsh RDS_GT_2A_SONDERZEICHEN_BLOCK2
;-------------------------------------------------------------------------------
RDS_GT_2A_SONDERZEICHEN_BLOCK1:
	; SCHLEIFE=64-POSITION		
	ldi temp1,64	; Schleife	
	sub temp1,temp9	
RDS_GT_2A_SONDERZEICHEN_BLOCK1_s:
	ST Y+,temp
	dec temp1
	brne RDS_GT_2A_SONDERZEICHEN_BLOCK1_s
	ret
;-------------------------------------------------------------------------------
RDS_GT_2A_SONDERZEICHEN_BLOCK2:
	; SCHLEIFE=128-POSITION		
	ldi temp1,128	; Schleife	
	sub temp1,temp9	
RDS_GT_2A_SONDERZEICHEN_BLOCK2_s:
	ST Y+,temp
	dec temp1
	brne RDS_GT_2A_SONDERZEICHEN_BLOCK2_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ZEIT 																			
RDS_GT_4A:
	; Offset (in 30 Min)
	LDS temp,(adr_RDS_DL)
	andi temp,0b00111111
	STS(adr_RDS_ZEIT_OFFSET),temp
	; Minuten			
	LDS temp1,(adr_RDS_DH)
	LDS temp ,(adr_RDS_DL)
	LSR temp1	; 6 mal rechts
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	andi temp,0b00111111
	STS(adr_RDS_ZEIT_MM),temp
	; Stunden			
	LDS temp1,(adr_RDS_CL)
	LDS temp ,(adr_RDS_DH)
	LSR temp1	; 4 mal rechts
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	andi temp,0b00011111
	STS(adr_RDS_ZEIT_HH),temp
;-------------------------------------------------------------------------------
	; Offsetwert x 30			
	LDS temp1,(adr_RDS_ZEIT_OFFSET)
	mov temp,temp1
	ldi temp9,29	; 29 x addieren
RDS_GT_4A_s:
	add temp1,temp
	dec temp9
	brne RDS_GT_4A_s

	mov temp9,temp1	; Schleife
	LDS temp1,(adr_RDS_ZEIT_mm)	; mm
	LDS temp2,(adr_RDS_ZEIT_hh)	; hh
RDS_GT_4A_SCHLEIFE:
	inc temp1		; mm
	cpi temp1,60
	brsh RDS_GT_4A_HH
	rjmp RDS_GT_4A_w
RDS_GT_4A_HH:
	clr temp1		; mm
	inc temp2		; hh
	cpi temp2,24
	brsh RDS_GT_4A_TAG
	rjmp RDS_GT_4A_w
RDS_GT_4A_TAG:
	clr temp2		; hh
RDS_GT_4A_w:
	dec temp9		; Schleife
	brne RDS_GT_4A_SCHLEIFE
	STS(adr_RDS_ZEIT_mm),temp1	; mm
	STS(adr_RDS_ZEIT_hh),temp2	; hh
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

