; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_SAMPLING:
	; SAMPLING						
	sbic (DATA_PIN),(DATA_PIN_NR)	; Sprung, wenn Bit clear
	rjmp RDS_SAMPLING_HIGH
RDS_SAMPLING_LOW:
	CLC ; clear CARRY	
	rjmp RDS_SAMPLING_W
RDS_SAMPLING_HIGH:
	SEC	; set CARRY		
RDS_SAMPLING_W:
	; alles 1x links ber Carry	
	LDS temp1,(adr_RDS_DATA0)	; LSB
	LDS temp2,(adr_RDS_DATA1)
	LDS temp3,(adr_RDS_DATA2)
	LDS temp4,(adr_RDS_DATA3)	; MSB
	ROL temp1
	ROL temp2
	ROL temp3
	ROL temp4
	STS(adr_RDS_DATA0),temp1	; LSB
	STS(adr_RDS_DATA1),temp2
	STS(adr_RDS_DATA2),temp3
	STS(adr_RDS_DATA3),temp4	; MSB
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; REGISTER:																		
; temp  = DUMMY																	
; temp1 = CRC (empfangen)														
; temp2 = CRC (empfangen)														
; temp3 = DATEN																	
; temp4 = DATEN																	
; temp5 = CRC (berechnet)														
; temp6 = CRC (berechnet)														
; temp7 =																		
; temp8 =																		
; temp9 = SCHLEIFE																
;																				
; Rckgabewert temp1:															
; 0	= nix																		
; 1	= Gruppe-A																	
; 2	= Gruppe-B																	
; 3	= Gruppe-C																	
; 4	= Gruppe-D																	
; 255= ERROR 																	
RDS_CRC_TEMP1:
	; ZHLER BYTES-1	
	LDS temp,(adr_RDS_ZAEHLER_BYTES)
	dec temp
	STS(adr_RDS_ZAEHLER_BYTES),temp
	; ZHLER BYTES=0	
	tst temp
	breq RDS_CRC_RUN
	ldi temp1,0	; RCKGABEWERT	
	ret
;-------------------------------------------------------------------------------
RDS_CRC_RUN:
	; LADEN						
	LDS temp1,(adr_RDS_DATA0)	; LSB
	LDS temp2,(adr_RDS_DATA1)
	LDS temp3,(adr_RDS_DATA2)
	LDS temp4,(adr_RDS_DATA3)	; MSB
;-------------------------------------------------------------------------------
	; CRC empfangen aufbereiten	(6xrechts)
	ldi temp9,6		; SCHLEIFE
RDS_CRC_S0:
	LSR temp2 		; CRC(empfangen)	
	ROR temp1 		; CRC(empfangen)	
	dec temp9		; SCHLEIFE	
	brne RDS_CRC_S0
;-------------------------------------------------------------------------------
	; ZHLER BYTES=26				
	ldi temp,(26)
	STS(adr_RDS_ZAEHLER_BYTES),temp
	; CRC						
	clr temp5		; CRC (berechnet)		
	clr temp6		; CRC (berechnet)		
;-------------------------------------------------------------------------------
	; Schleife 1 "DATA" 16 x nach links
	ldi temp9,16	; SCHLEIFE
RDS_CRC_S1:
	LSL temp3		
	ROL temp4
	ROL temp5		; CRC (berechnet)		
	ROL temp6		; CRC (berechnet)		
	sbrs temp6,2			; Bit 10 gesetzt ?
	rjmp RDS_CRC_S1_NO_XOR
	; XOR mit POLYNOM	
	ldi temp,LOW(POLYNOM)
	eor temp5,temp 	; CRC (berechnet)		
	ldi temp,HIGH(POLYNOM)
	eor temp6,temp 	; CRC (berechnet)		
RDS_CRC_S1_NO_XOR:
	dec temp9		; SCHLEIFE
	brne RDS_CRC_S1
;-------------------------------------------------------------------------------
	; Schleife 2 "CRC" 10 x nach links
	ldi temp9,10	; SCHLEIFE
RDS_CRC_S2:
	LSL temp5
	ROL temp6
	sbrs temp6,2	; Bit 10 gesetzt ?
	rjmp RDS_CRC_S2_NO_XOR
	; XOR mit POLYNOM	
	ldi temp,LOW(POLYNOM)
	eor temp5,temp 	; CRC (berechnet)		
	ldi temp,HIGH(POLYNOM)
	eor temp6,temp 	; CRC (berechnet)		
RDS_CRC_S2_NO_XOR:
	dec temp9		; SCHLEIFE
	brne RDS_CRC_S2
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
RDS_GRUPPENTYP_A:
  	; CRC Kopie							
	mov temp3,temp5	; CRC (berechnet) 	
	mov temp4,temp6	; CRC (berechnet)	
	; "CRC"mit OFFSET_WORD_A verknpfen	
  	ldi  temp,low(OFFSET_WORD_A)
  	eor  temp3,temp
  	ldi  temp,high(OFFSET_WORD_A)
  	eor  temp4,temp
	; Vergleich mit empfangenem "CRC"	
	cp temp1,temp3 	; CRC(empfangen)	
	brne RDS_GRUPPENTYP_NO_A
	cp temp2,temp4 	; CRC(empfangen)	
	brne RDS_GRUPPENTYP_NO_A
	; ERGEBNIS
	LDS temp4,(adr_RDS_DATA3)		; aus SRAM laden	
	LDS temp3,(adr_RDS_DATA2)
	STS(adr_RDS_GRUPPE_AH_ROH),temp4 	; im SRAM ablegen	
	STS(adr_RDS_GRUPPE_AL_ROH),temp3
	ldi temp1,1	; RCKGABEWERT	
	ret
RDS_GRUPPENTYP_NO_A:
;-------------------------------------------------------------------------------
RDS_GRUPPENTYP_B:
  	; CRC Kopie							
	mov temp3,temp5	; CRC (berechnet) 	  
	mov temp4,temp6	; CRC (berechnet) 	  
	; "CRC"mit OFFSET_WORD_B verknpfen	
  	ldi  temp,low(OFFSET_WORD_B)
  	eor  temp3,temp
  	ldi  temp,high(OFFSET_WORD_B)
  	eor  temp4,temp
	; Vergleich mit empfangenem "CRC"	
	cp temp1,temp3 	; CRC(empfangen)	
	brne RDS_GRUPPENTYP_NO_B
	cp temp2,temp4 	; CRC(empfangen)	
	brne RDS_GRUPPENTYP_NO_B
	; ERGEBNIS					
	LDS temp4,(adr_RDS_DATA3)		; aus SRAM laden	
	LDS temp3,(adr_RDS_DATA2)
	STS(adr_RDS_GRUPPE_BH_ROH),temp4 	; im SRAM ablegen
	STS(adr_RDS_GRUPPE_BL_ROH),temp3
	ldi temp1,2	; RCKGABEWERT	
	ret
RDS_GRUPPENTYP_NO_B:
;-------------------------------------------------------------------------------
RDS_GRUPPENTYP_C:
  	; CRC Kopie							
	mov temp3,temp5	; CRC (berechnet) 	
	mov temp4,temp6	; CRC (berechnet) 	
	; "CRC"mit OFFSET_WORD_C verknpfen	
  	ldi  temp,low(OFFSET_WORD_C)
  	eor  temp3,temp
  	ldi  temp,high(OFFSET_WORD_C)
  	eor  temp4,temp
	; Vergleich mit empfangenem "CRC"	
	cp temp1,temp3 	; CRC(empfangen)	
	brne RDS_GRUPPENTYP_NO_C
	cp temp2,temp4 	; CRC(empfangen)	
	brne RDS_GRUPPENTYP_NO_C
	; ERGEBNIS							
	LDS temp4,(adr_RDS_DATA3)		; aus SRAM laden	
	LDS temp3,(adr_RDS_DATA2)
	STS(adr_RDS_GRUPPE_CH_ROH),temp4 	; im SRAM ablegen
	STS(adr_RDS_GRUPPE_CL_ROH),temp3
	ldi temp1,3	; RCKGABEWERT	
	ret
RDS_GRUPPENTYP_NO_C:
;-------------------------------------------------------------------------------
RDS_GRUPPENTYP_D:
  	; CRC Kopie							
	mov temp3,temp5	; CRC (berechnet) 	
	mov temp4,temp6	; CRC (berechnet) 	
	; "CRC"mit OFFSET_WORD_D verknpfen	
  	ldi  temp,low(OFFSET_WORD_D)
  	eor  temp3,temp
  	ldi  temp,high(OFFSET_WORD_D)
  	eor  temp4,temp
	; Vergleich mit empfangenem "CRC"	
	cp temp1,temp3 	; CRC(empfangen)	
	brne RDS_GRUPPENTYP_NO_D
	cp temp2,temp4 	; CRC(empfangen)	
	brne RDS_GRUPPENTYP_NO_D
	; ERGEBNIS							
	LDS temp4,(adr_RDS_DATA3)		; aus SRAM laden	
	LDS temp3,(adr_RDS_DATA2)
	STS(adr_RDS_GRUPPE_DH_ROH),temp4 	; im SRAM ablegen
	STS(adr_RDS_GRUPPE_DL_ROH),temp3
	ldi temp1,4	; RCKGABEWERT	
	ret
RDS_GRUPPENTYP_NO_D:
;-------------------------------------------------------------------------------
RDS_GRUPPENTYP_ERROR:
	ldi temp1,255							; RCKGABEWERT			
	STS(adr_RDS_ZAEHLER_BYTES),EINS			; ZHLER BYTES=1		
	STS(adr_RDS_ZAEHLER_GRUPPENTYP),NULL	; ZAEHLER_GRUPPENTYP=0	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; input: temp1 (Gruppentyp)
RDS_GRUPPENBILDUNG_TEMP1:
	; Rckgabewert = 0  (nix tun)
	cpi temp1,0	
	brne RDS_GRUPPENBILDUNG_RUN	
	ret
;-------------------------------------------------------------------------------
RDS_GRUPPENBILDUNG_RUN:
	; Rckgabewert =255 (ERROR)			
	cpi temp1,255
	breq RDS_GRUPPENBILDUNG_ERROR 	
	; ZAEHLER_GRUPPENTYP + 1			
	LDS temp2,(adr_RDS_ZAEHLER_GRUPPENTYP)
	inc temp2
	STS(adr_RDS_ZAEHLER_GRUPPENTYP),temp2
	; Rckgabewert=ZAEHLER_GRUPPENTYP ?	
	cp temp1,temp2
	brne RDS_GRUPPENBILDUNG_ERROR
	; Rckgabewert=4 ?					
	cpi temp1,4
	breq RDS_GRUPPENBILDUNG_FERTIG
	ret
;-------------------------------------------------------------------------------
; ERROR																			
RDS_GRUPPENBILDUNG_ERROR:
	STS(adr_RDS_ZAEHLER_GRUPPENTYP),NULL		; ZAEHLER_GRUPPENTYP=0	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	cbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB an	
	; STSTISTIK	
	LDS temp1,(adr_RDS_ZAEHLER_ANZ_GRUPPEN_ERROR_L)
	LDS temp2,(adr_RDS_ZAEHLER_ANZ_GRUPPEN_ERROR_H)
	add temp1,EINS
	adc temp2,NULL
	STS(adr_RDS_ZAEHLER_ANZ_GRUPPEN_ERROR_L),temp1	
	STS(adr_RDS_ZAEHLER_ANZ_GRUPPEN_ERROR_H),temp2	

	ret
;-------------------------------------------------------------------------------
RDS_GRUPPENBILDUNG_FERTIG:
	STS(adr_RDS_ZAEHLER_GRUPPENTYP),NULL		; ZAEHLER_GRUPPENTYP=0	
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN  an	
	sbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB aus	
	; STSTISTIK	
	LDS temp1,(adr_RDS_ZAEHLER_ANZ_GRUPPEN_L)
	LDS temp2,(adr_RDS_ZAEHLER_ANZ_GRUPPEN_H)
	add temp1,EINS
	adc temp2,NULL
	STS(adr_RDS_ZAEHLER_ANZ_GRUPPEN_L),temp1	
	STS(adr_RDS_ZAEHLER_ANZ_GRUPPEN_H),temp2	

	rcall RDS_BUFFER_WRITE
ret	
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_BUFFER_WRITE:
	; Z BERECHNEN						
	ldi ZL,LOW (adr_RDS_DISPLAY_BUFFER256)
	ldi ZH,HIGH(adr_RDS_DISPLAY_BUFFER256)
	LDS temp,(adr_RDS_ZAEHLER_BUFFER_WRITE)
	add ZL,temp
	adc ZH,NULL
	; ZAEHLER_BUFFER_WRITE+8			
	subi temp,-8
	STS(adr_RDS_ZAEHLER_BUFFER_WRITE),temp
;-------------------------------------------------------------------------------
	; PUFFER VOLL ?						
	LD temp,Z
	tst temp
	breq RDS_BUFFER_WRITE_NO_ERROR
	; ERROR								
	ldi temp,(ERROR_RDS_BUFFER)
	STS(adr_ERROR_CODE),temp
RDS_BUFFER_WRITE_NO_ERROR:
;-------------------------------------------------------------------------------
	; Gruppen in den Puffer schreiben	
	LDS temp,(adr_RDS_GRUPPE_AH_ROH)
	ST Z+,temp
	LDS temp,(adr_RDS_GRUPPE_AL_ROH)
	ST Z+,temp
	LDS temp,(adr_RDS_GRUPPE_BH_ROH)
	ST Z+,temp
	LDS temp,(adr_RDS_GRUPPE_BL_ROH)
	ST Z+,temp
	LDS temp,(adr_RDS_GRUPPE_CH_ROH)
	ST Z+,temp
	LDS temp,(adr_RDS_GRUPPE_CL_ROH)
	ST Z+,temp
	LDS temp,(adr_RDS_GRUPPE_DH_ROH)
	ST Z+,temp
	LDS temp,(adr_RDS_GRUPPE_DL_ROH)
	ST Z+,temp
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

