; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; (adr_ZAEHLER_BUFFER_WRITE)
	LDS temp,(adr_RDS_ZAEHLER_BUFFER_WRITE)
	andi temp,0b00000111
	tst temp
	brne PROGRAMM_CHECK_FEHLER
	; (adr_ZAEHLER_BUFFER_READ)
	LDS temp,(adr_RDS_ZAEHLER_BUFFER_READ)
	andi temp,0b00000111
	tst temp
	brne PROGRAMM_CHECK_FEHLER
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	ret
;-------------------------------------------------------------------------------
; SCHLEIFE																		
PROGRAMM_CHECK_FEHLER:
	CLI											; Interrupts sperren !				
	rcall wait_100ms
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEST:
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	sbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP aus	
	sbi (RELAIS_PORT),(RELAIS_PIN_NR)			; RELAIS aus

	cbi (RELAIS_PORT),(RELAIS_PIN_NR)			; RELAIS an	
	rcall wait_100ms
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an   
	rcall wait_100ms
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	rcall wait_100ms
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	cbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP an	
	rcall wait_20ms


	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	sbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP aus	
	sbi (RELAIS_PORT),(RELAIS_PIN_NR)			; RELAIS aus
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_KLICK:
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTEN_KLICK_RUN
	ret
TASTEN_KLICK_RUN:
	cbi (BEEP_PORT),(BEEP_PIN_NR)			; BEEP an	
	rcall wait_20ms
	sbi (BEEP_PORT),(BEEP_PIN_NR)			; BEEP aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_RESET:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_RESET)
	breq TASTEN_RESET_ACTION
	ret
TASTEN_RESET_ACTION:
	CLI											; Interrupts sperren !				
	rcall ANZEIGE_TEST
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an   
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	cbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP an	
	rcall wait_100ms
	rcall wait_100ms
	sbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP aus	
TASTEN_RESET_ACTION_s:
	rjmp TASTEN_RESET_ACTION_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTE_MINUS_GEDRUECKT_CARRY:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_MENUE_MINUS)
	breq TASTE_MINUS_GEDRUECKT_CARRY_YES
TASTE_MINUS_GEDRUECKT_CARRY_NO:
	CLC	; Clear CARRY	
	ret
TASTE_MINUS_GEDRUECKT_CARRY_YES:
	SEC ; Set Carry		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
VERKEHRSDURCHSAGE:
	LDS temp,(adr_RDS_TP); Verkersfunksender
	tst temp
	brne VERKEHRSDURCHSAGE_w
	sbi (RELAIS_PORT),(RELAIS_PIN_NR)			; RELAIS aus
	ret
VERKEHRSDURCHSAGE_w:
	LDS temp,(adr_RDS_TA); Verkehrsdurchsage
	tst temp
	brne VERKEHRSDURCHSAGE_ww
	sbi (RELAIS_PORT),(RELAIS_PIN_NR)			; RELAIS aus
	ret
VERKEHRSDURCHSAGE_ww:	
	cbi (RELAIS_PORT),(RELAIS_PIN_NR)			; RELAIS an	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
