; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER_AKTIVIEREN:
;																			
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)		
;																			
; TIMSK ==> OCIE2 TOIE2 TICIE1 OCIE1A OCIE1B TOIE1 R TOIE0  				
;																			
	ldi temp,(0<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(1<<TOIE1)|(0<<TOIE0)
	out TIMSK,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER1_INITIALISIERUNG:
;																			
; Timer1 (16Bit ) Vorteiler 												
;																			
; TCCR1B ==> ICNC1 ICES1 RESERVIERT WGM13 WGM12 CS12 CS11 CS10 				
;																			
;CS12 CS11 CS10 Description													
;	0	0 	0 	No clock source. (Timer/Counter stopped)					
;	0 	0 	1 	clkI/O/1    (No prescaling)									
;	0 	1 	0 	clkI/O/8    (From prescaler)								
;	0 	1 	1 	clkI/O/64   (From prescaler)								
;	1 	0 	0 	clkI/O/256  (From prescaler)								
; *	1 	0 	1 	clkI/O/1024 (From prescaler)								
;	1 	1 	0 	External clock source on T1 pin. Clock on falling edge.		
;	1 	1 	1 	External clock source on T1 pin. Clock on rising edge.		
;																			
	ldi temp,(1<<CS12)|(0<<CS11) |(1<<CS10)
	out TCCR1B,temp          
; Timer 1 Startwert 	
	ldi temp,HIGH(TIMERWERT1)
	out tcnt1H,temp         
	ldi temp,LOW (TIMERWERT1) 
	out tcnt1L,temp     
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei 16 MHz ==> 1s Takt														
TIM1_OVF:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
; ----------------------------------
; Timer Startwert	 				
	ldi temp,HIGH(TIMERWERT1)
	out tcnt1H,temp         
	ldi temp,LOW (TIMERWERT1) 
	out tcnt1L,temp
; ----------------------------------
	inc SEKUNDE
; ----------------------------------
; FREQUENZ-A						
	STS(adr_FREQUENZA_0),FREQA0
	STS(adr_FREQUENZA_1),FREQA1
	clr FREQA0
	clr FREQA1
; ----------------------------------
; FREQUENZ-B
	LDS temp,(adr_FREQUENZB_ZAEHLER)
	dec temp
	STS(adr_FREQUENZB_ZAEHLER),temp
	tst temp
	brne TIM1_OVF_B_FERTIG
	ldi temp,10
	STS(adr_FREQUENZB_ZAEHLER),temp

	STS(adr_FREQUENZB_0),FREQB0
	STS(adr_FREQUENZB_1),FREQB1
	STS(adr_FREQUENZB_2),FREQB2

	clr FREQB0
	clr FREQB1
	clr FREQB2
TIM1_OVF_B_FERTIG:
; ----------------------------------
; FREQUENZ-C						
	LDS temp,(adr_FREQUENZC_ZAEHLER)
	dec temp
	STS(adr_FREQUENZC_ZAEHLER),temp
	tst temp
	brne TIM1_OVF_C_FERTIG
	ldi temp,100
	STS(adr_FREQUENZC_ZAEHLER),temp

	STS(adr_FREQUENZC_0),FREQC0
	STS(adr_FREQUENZC_1),FREQC1
	STS(adr_FREQUENZC_2),FREQC2

	clr FREQC0
	clr FREQC1
	clr FREQC2
TIM1_OVF_C_FERTIG:
; ----------------------------------
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 				
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################

